#pragma once
#ifndef FILTER_HOME_H
#define FILTER_HOME_H

#include "auktion.h"

#include <cassert>
#include <map>
#include <string>

namespace Auktion {

    class FilterHome_impl: virtual public CCM_FilterHome
    {
        public:
            FilterHome_impl(void);
            virtual ~FilterHome_impl(void);

            //  comes from FilterHomeImplicit
            virtual ::Components::EnterpriseComponent_ptr create();
            //  comes from FilterHomeExplicit
            virtual ::Components::EnterpriseComponent_ptr new_filter(const char* gegenstand);

        private:
            //  to make it easier for us...
            typedef std::map<std::string, ::Components::EnterpriseComponent_ptr> STD_MAP;

            STD_MAP table_;     //  internal dictionary ensures that only one
                                //  filter instance exists for 'gegenstand'
    };

}

#endif  //  FILTER_HOME_H
